## fenics-basix 0.9.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

project(BasixFull VERSION "0.9.0" LANGUAGES CXX)
set(BASIX_FULL_SKBUILD TRUE)
add_subdirectory(cpp)
add_subdirectory(python)

=== cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

# Set the version
project(Basix VERSION "0.9.0" LANGUAGES CXX)
include(GNUInstallDirs)

if(SKBUILD AND UNIX)
  # Avoid lib64/ which can lead to linking issues.
  set(CMAKE_INSTALL_LIBDIR basix/lib)
endif()

if (SKBUILD)
  # Make sure includes end up inside basix/ subdirectory in wheel. 
  set(CMAKE_INSTALL_INCLUDEDIR basix/include)
  # Make sure all binaries end up inside basix/ subdirectory in wheel.
  set(CMAKE_INSTALL_BINDIR basix)
endif()

include(FeatureSummary)

# Options
option(BUILD_SHARED_LIBS "Build Basix with shared libraries." ON)
add_feature_info(BUILD_SHARED_LIBS BUILD_SHARED_LIBS "Build Basix with shared libraries.")

option(INSTALL_RUNTIME_DEPENDENCIES "Include runtime dependencies in install (Windows-only)" OFF)
add_feature_info(INSTALL_RUNTIME_DEPENDENCIES INSTALL_RUNTIME_DEPENDENCIES "Include runtime dependencies in install (Windows-only)")

find_package(BLAS REQUIRED)
find_package(LAPACK REQUIRED)

feature_summary(WHAT ALL)

if (WIN32)
    # Windows requires all symbols to be manually exported.
    # This flag exports all symbols automatically, as in Unix.
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
endif()

# Source files
add_library(basix)

# Set the C++ standard
target_compile_features(basix PUBLIC cxx_std_20)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/basix/version.h.in basix/version.h)
target_include_directories(basix PRIVATE ${CMAKE_CURRENT_BINARY_DIR})

set(HEADERS_basix
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/cell.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/dof-transformations.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/element-families.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/finite-element.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/indexing.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/interpolation.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/lattice.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/maps.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/math.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/moments.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/polynomials.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/polyset.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/precompute.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/quadrature.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/sobolev-spaces.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-lagrange.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nce-rtc.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-brezzi-douglas-marini.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nedelec.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-raviart-thomas.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-regge.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-hhj.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-crouzeix-raviart.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-bubble.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-serendipity.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-hermite.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/mdspan.hpp
  ${CMAKE_CURRENT_BINARY_DIR}/basix/version.h)

target_sources(basix PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/cell.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/dof-transformations.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/finite-element.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/interpolation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/lattice.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/moments.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/polynomials.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/polyset.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/precompute.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/quadrature.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/sobolev-spaces.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-lagrange.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nce-rtc.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-brezzi-douglas-marini.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nedelec.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-raviart-thomas.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-regge.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-hhj.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-crouzeix-raviart.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-bubble.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-hermite.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-serendipity.cpp)

# Configure the library
set_target_properties(basix PROPERTIES PUBLIC_HEADER basix/finite-element.h)
set_target_properties(basix PROPERTIES PRIVATE_HEADER "${HEADERS_basix}")
target_include_directories(basix PUBLIC
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_SOURCE_DIR}>")

target_link_libraries(basix PRIVATE BLAS::BLAS)
target_link_libraries(basix PRIVATE LAPACK::LAPACK)

if (UNIX)
    list(APPEND BASIX_DEVELOPER_FLAGS -O2;-g;-pipe)
    list(APPEND BASIX_COMPILER_FLAGS -Wall;-Werror;-Wextra;-Wno-comment;-pedantic;)
    target_compile_options(basix PRIVATE "$<$<OR:$<CONFIG:Debug>,$<CONFIG:Developer>>:${BASIX_COMPILER_FLAGS}>")
    target_compile_options(basix PRIVATE $<$<CONFIG:Developer>:${BASIX_DEVELOPER_FLAGS}>)
endif()

if (MSVC)
    # M_PI etc. are not not in the standard-compliant MSVC headers.
    target_compile_definitions(basix PUBLIC _USE_MATH_DEFINES)
endif()


# TODO: This if can be removed once all platforms have CMake 3.21.
if (WIN32)
  install(TARGETS basix
  EXPORT BasixTargets
  RUNTIME_DEPENDENCY_SET dependencies
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  PRIVATE_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/basix
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeExecutables
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
  )
  if (INSTALL_RUNTIME_DEPENDENCIES)
    LIST(APPEND PRE_EXCLUDE_REGEXES "api-ms-.*")
    LIST(APPEND PRE_EXCLUDE_REGEXES "ext-ms-.*")
    install(RUNTIME_DEPENDENCY_SET dependencies DESTINATION ${CMAKE_INSTALL_BINDIR} PRE_EXCLUDE_REGEXES ${PRE_EXCLUDE_REGEXES} POST_EXCLUDE_REGEXES ".*system32/.*\\.dll" )
  endif()
else()
  install(TARGETS basix
  EXPORT BasixTargets
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  PRIVATE_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/basix
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeExecutables
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
  )
endif()

# Configure CMake helpers
include(CMakePackageConfigHelpers)
write_basic_package_version_file(BasixConfigVersion.cmake VERSION ${PACKAGE_VERSION}
  COMPATIBILITY AnyNewerVersion)
configure_package_config_file(BasixConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/BasixConfig.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/basix)

# Install CMake files
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/BasixConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/BasixConfigVersion.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/basix COMPONENT Development)
install(EXPORT BasixTargets FILE BasixTargets.cmake NAMESPACE Basix::
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/basix)

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

# nanobind uses aligned deallocators only present on macOS > 10.14
if(APPLE)
  set(CMAKE_OSX_DEPLOYMENT_TARGET "10.14")
endif()

project(basix_nanobind VERSION "0.9.0.0" LANGUAGES CXX)

if (WIN32)
    # Windows requires all symbols to be manually exported.
    # This flag exports all symbols automatically, as in Unix.
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
endif(WIN32)

# See https://gitlab.kitware.com/cmake/cmake/-/issues/16414
if(TARGET basix)
  add_library(Basix::basix ALIAS basix)
else()
  find_package(Basix REQUIRED)
endif()

find_package(Python COMPONENTS Interpreter Development.Module REQUIRED)

# Detect the installed nanobind package and import it into CMake
execute_process(
  COMMAND "${Python_EXECUTABLE}" -c "import nanobind; print(nanobind.cmake_dir())"
  OUTPUT_STRIP_TRAILING_WHITESPACE OUTPUT_VARIABLE NB_DIR)
list(APPEND CMAKE_PREFIX_PATH "${NB_DIR}")
find_package(nanobind CONFIG REQUIRED)

# Create the binding library
nanobind_add_module(_basixcpp wrapper.cpp)
target_compile_definitions(_basixcpp PRIVATE cxx_std_20)
target_link_libraries(_basixcpp PRIVATE Basix::basix)

# Add strict compiler flags
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-Wall -Werror -Wextra -Wno-comment -pedantic" HAVE_PEDANTIC)

if(HAVE_PEDANTIC)
  target_compile_options(_basixcpp PRIVATE -Wall;-Wextra;-Werror;-Wno-comment)
endif()

# TODO: remove after issue https://github.com/FEniCS/basix/issues/842 is resolved
target_compile_definitions(_basixcpp PRIVATE MDSPAN_USE_PAREN_OPERATOR=1)
target_compile_definitions(_basixcpp PRIVATE MDSPAN_USE_BRACKET_OPERATOR=0)

# Add relative rpath so _basixcpp can find the Basix::basix library
# when the build is relocated
if(BASIX_FULL_SKBUILD)
  if(APPLE)
    set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH "@loader_path/lib")
  elseif(UNIX)
    set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH "$ORIGIN/lib")
  endif()
else()
  get_target_property(_location Basix::basix LOCATION)
  get_filename_component(_basix_dir ${_location} DIRECTORY)
  set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH ${_basix_dir})
endif()

install(TARGETS _basixcpp LIBRARY DESTINATION basix)

=== test/test_cmake/CMakeLists.txt ===
# Example of CMakeLists.txt for downstream C++ project (eg DOLFINx or a Basix demo)
# Used to check correctly installed package during tests and wheel creation.
cmake_minimum_required(VERSION 3.16)

project(basix_test)

# Set the C++ standard
set(CMAKE_CXX_STANDARD 23)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Use Python for detecting Basix
find_package(Python3 COMPONENTS Interpreter)

if (${Python3_FOUND})
  execute_process(
    COMMAND ${Python3_EXECUTABLE} -c "import basix, os, sys; sys.stdout.write(os.path.dirname(basix.__file__))"
    OUTPUT_VARIABLE BASIX_PY_DIR
    RESULT_VARIABLE BASIX_PY_COMMAND_RESULT
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
  if (BASIX_PY_DIR)
    message(STATUS "Adding ${BASIX_PY_DIR} to Basix search hints")
  endif()
endif()
find_package(Basix REQUIRED CONFIG HINTS ${BASIX_PY_DIR})

add_executable(a.out main.cpp)
if (BASIX_PY_DIR AND IS_DIRECTORY ${BASIX_PY_DIR}/../fenics_basix.libs)
    set_target_properties(a.out PROPERTIES BUILD_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
    set_target_properties(a.out PROPERTIES INSTALL_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
endif()
target_link_libraries(a.out PRIVATE Basix::basix)

=== demo/cpp/demo_create_and_tabulate/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(demo_create_and_tabulate LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Use Python for detecting Basix when installed using combined build
find_package(Python3 COMPONENTS Interpreter)
if (${Python3_FOUND})
  execute_process(
    COMMAND ${Python3_EXECUTABLE} -c "import basix, os, sys; sys.stdout.write(os.path.dirname(basix.__file__))"
    OUTPUT_VARIABLE BASIX_PY_DIR
    RESULT_VARIABLE BASIX_PY_COMMAND_RESULT
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
  if (BASIX_PY_DIR)
    message(STATUS "Adding ${BASIX_PY_DIR} to Basix search hints")
  endif()
endif()
find_package(Basix REQUIRED CONFIG HINTS ${BASIX_PY_DIR})

add_executable(${PROJECT_NAME} main.cpp)

if (BASIX_PY_DIR AND IS_DIRECTORY ${BASIX_PY_DIR}/../fenics_basix.libs)
    set_target_properties(${PROJECT_NAME} PROPERTIES BUILD_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
    set_target_properties(${PROJECT_NAME} PROPERTIES INSTALL_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
endif()
target_link_libraries(${PROJECT_NAME} Basix::basix)

=== debian/changelog ===
fenics-basix (0.9.0-4) unstable; urgency=medium

  * update Breaks: python3-dolfinx (<< 1:0.9.0-8~),
    python3-dolfinx-mpc (<< 0.9.3-2~), python3-scifem (<< 0.10.0-1~)
    to allow for breakage of old packages built
    with old nanobind 2.5 (api15). Closes: #1117555.

 -- Drew Parsons <dparsons@debian.org>  Wed, 08 Oct 2025 11:25:19 +0200

fenics-basix (0.9.0-3) unstable; urgency=medium

  * debian patch python_depends_nanobind.patch adds nanobind to python
    dependencies (pyproject.toml) so dh_python3 catches the nanobind ABI.
    See nanobind transition Bug#1111004.
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Wed, 10 Sep 2025 12:53:06 +0200

fenics-basix (0.9.0-2) unstable; urgency=medium

  * Upload to unstable
  * Drop python3-basix Recommends: python3-numba, since numba is not available
    on all arches and is sometimes problematic on debci
  * Fix lower bound on fenics-ufl in python3-basix: it must be 2024.2.0~, and
    not 2024.1.0~.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Tue, 05 Nov 2024 08:04:26 +0000

fenics-basix (0.9.0-1exp1) experimental; urgency=medium

  * New upstream release 0.9.0:
    - new ABI 0.9
  * Refresh the following patches
    - cmake_shared_library.patch
    because they failed to apply on the new release.
  * Refresh the following patches
    - find_generic_blas.patch
    - python_local_LICENSE.patch
    - skip_runpath.patch
    to ensure that the apply without fuzz on the new release.
  * Drop the following patches
    - PR825.diff
    because they were included upstream in the new release.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 20 Oct 2024 13:29:44 +0000

=== debian/control ===
Source: fenics-basix
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>,
           Francesco Ballarin <francesco.ballarin@unicatt.it>
Section: python
Testsuite: autopkgtest-pkg-python
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5),
               debhelper-compat (= 13),
               dh-sequence-python3,
               python3-setuptools,
               python3-all-dev:any,
               python3-ufl (>= 2024.2.0~),
               python3-nanobind (>= 2.0.0~),
               python3-numpy,
               pybuild-plugin-pyproject,
               python3-pytest,
               python3-scikit-build-core,
               python3-sphinx,
               python3-sympy,
               python3-wheel,
               cmake,
               chrpath,
               cython3,
               libeigen3-dev,
               libjs-mathjax,
               ninja-build,
               libblas-dev | libopenblas-dev | libblis-dev | libatlas-base-dev | libblas.so,
               liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so
Build-Depends-Indep: doxygen,
                     graphviz
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/fenics/fenics-basix
Vcs-Git: https://salsa.debian.org/science-team/fenics/fenics-basix.git
Homepage: https://github.com/FEniCS/basix
Rules-Requires-Root: no

Package: libbasix-dev
Architecture: any
Multi-Arch: same
Depends: libbasix0.9 (= ${binary:Version}),
         libeigen3-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: python3-basix,
          basix-doc
Description: Finite Element Basis Function Definition Runtime Library (development headers)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 Python wrapper provided with pybind11.
 .
 This package installs the development files for the shared library.

Package: libbasix0.9
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: basix-doc
Provides: ${t64:Provides}
Description: Finite Element Basis Function Definition Runtime Library (Python 3)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 Python wrapper provided with pybind11.
 .
 This package installs the shared library.

Package: python3-basix
Architecture: any
Depends: libbasix-dev  (= ${binary:Version}),
         python3-ufl (>= 2024.1.0~),
         ${python3:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: basix-doc
Breaks: python3-ffcx (<< 1:0.4~),
        python3-dolfinx (<< 1:0.9.0-8~),
        python3-dolfinx-real (<< 1:0.9.0-8~),
        python3-dolfinx-complex (<< 1:0.9.0-8~),
        python3-dolfinx-mpc (<< 0.9.3-2~),
        python3-scifem (<< 0.10.0-1~)
Description: Finite Element Basis Function Definition Runtime Library (Python 3)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 Python wrapper provided with pybind11.
 .
 This package installs the library for Python 3.

Package: basix-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-mathjax,
         ${sphinxdoc:Depends},
         ${misc:Depends}
Suggests: python3-basix
Description: Finite Element Basis Function Definition Runtime Library (docs)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 This is the common documentation package.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk
export DEB_HOST_MULTIARCH

PY3VERS := $(shell py3versions -v --requested debian/control | tac -s' ')
PY3VER_DEFAULT := $(shell py3versions -dv)

PYTEST_OPTIONS = -k "not numba"

%:
	dh $@ --with sphinxdoc --buildsystem=cmake


override_dh_auto_clean:
	rm -rf cpp/basix/version.h
	rm -rf doc/cpp/html doc/cpp/latex
	rm -rf .pybuild
	rm -rf python/LICENSE
	rm -rf ./.pytest_cache test/.pytest_cache  test/__pycache__  python/testing_build
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure --sourcedir=cpp

override_dh_auto_build-indep: export http_proxy=127.0.0.1:9
override_dh_auto_build-indep: export https_proxy=127.0.0.1:9
override_dh_auto_build-indep:
	dh_auto_build --sourcedir=cpp -i
	cd doc/cpp; doxygen

execute_after_dh_auto_install:
	cp LICENSE python
	LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
	  CMAKE_PREFIX_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake \
	  pybuild --dir=$(CURDIR)/python --system=pyproject --name=basix --disable test

execute_before_dh_install-indep:
	LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
	  PYTHONPATH=$(CURDIR)/debian/python3-basix/usr/lib/python$(PY3VER_DEFAULT)/dist-packages:${PYTHONPATH} \
	  python3 -m sphinx -W -b html doc/python/source/ .pybuild/html/
	sed 's|href="https://fenicsproject.org/docs/basix/main/cpp/"|href="file:/usr/share/doc/basix-doc/cpp/index.html"|' -i .pybuild/html/index.html

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
execute_before_dh_python3:
	cd test; LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) PYTHONPATH=$(CURDIR)/debian/python3-basix/usr/lib/python$(PY3VER_DEFAULT)/dist-packages:${PYTHONPATH} pytest-3 $(PYTEST_OPTIONS)
endif

## fenics-basix 0.10.0.post0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

project(BasixFull VERSION "0.10.0" LANGUAGES CXX)
set(BASIX_FULL_SKBUILD TRUE)
add_subdirectory(cpp)
add_subdirectory(python)

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.21)
 
 # Set the version
-project(Basix VERSION "0.9.0" LANGUAGES CXX)
+project(Basix VERSION "0.10.0" LANGUAGES CXX)
 include(GNUInstallDirs)
 
 if(SKBUILD AND UNIX)
@@ -24,6 +24,9 @@
 
 option(INSTALL_RUNTIME_DEPENDENCIES "Include runtime dependencies in install (Windows-only)" OFF)
 add_feature_info(INSTALL_RUNTIME_DEPENDENCIES INSTALL_RUNTIME_DEPENDENCIES "Include runtime dependencies in install (Windows-only)")
+
+option(ENABLE_CLANG_TIDY "Run clang-tidy while building" OFF)
+add_feature_info(ENABLE_CLANG_TIDY ENABLE_CLANG_TIDY "Run clang-tidy while building")
 
 find_package(BLAS REQUIRED)
 find_package(LAPACK REQUIRED)
@@ -73,6 +76,7 @@
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-serendipity.h
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-hermite.h
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/mdspan.hpp
+  ${CMAKE_CURRENT_SOURCE_DIR}/basix/types.h
   ${CMAKE_CURRENT_BINARY_DIR}/basix/version.h)
 
 target_sources(basix PRIVATE
@@ -102,9 +106,18 @@
 # Configure the library
 set_target_properties(basix PROPERTIES PUBLIC_HEADER basix/finite-element.h)
 set_target_properties(basix PROPERTIES PRIVATE_HEADER "${HEADERS_basix}")
+
+if(ENABLE_CLANG_TIDY)
+  find_program(CLANG_TIDY NAMES clang-tidy REQUIRED)
+  set_target_properties(basix PROPERTIES CXX_CLANG_TIDY "${CLANG_TIDY};--config-file=${CMAKE_CURRENT_SOURCE_DIR}/../.clang-tidy")
+endif()
+
 target_include_directories(basix PUBLIC
   $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
   "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_SOURCE_DIR}>")
+
+target_compile_definitions(basix PUBLIC MDSPAN_USE_PAREN_OPERATOR=1)
+target_compile_definitions(basix PUBLIC MDSPAN_USE_BRACKET_OPERATOR=0)
 
 target_link_libraries(basix PRIVATE BLAS::BLAS)
 target_link_libraries(basix PRIVATE LAPACK::LAPACK)
@@ -121,10 +134,7 @@
     target_compile_definitions(basix PUBLIC _USE_MATH_DEFINES)
 endif()
 
-
-# TODO: This if can be removed once all platforms have CMake 3.21.
-if (WIN32)
-  install(TARGETS basix
+install(TARGETS basix
   EXPORT BasixTargets
   RUNTIME_DEPENDENCY_SET dependencies
   PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
@@ -132,21 +142,10 @@
   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeExecutables
   LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
   ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
-  )
-  if (INSTALL_RUNTIME_DEPENDENCIES)
-    LIST(APPEND PRE_EXCLUDE_REGEXES "api-ms-.*")
-    LIST(APPEND PRE_EXCLUDE_REGEXES "ext-ms-.*")
-    install(RUNTIME_DEPENDENCY_SET dependencies DESTINATION ${CMAKE_INSTALL_BINDIR} PRE_EXCLUDE_REGEXES ${PRE_EXCLUDE_REGEXES} POST_EXCLUDE_REGEXES ".*system32/.*\\.dll" )
-  endif()
-else()
-  install(TARGETS basix
-  EXPORT BasixTargets
-  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
-  PRIVATE_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/basix
-  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeExecutables
-  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
-  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
-  )
+)
+if (INSTALL_RUNTIME_DEPENDENCIES AND WIN32)
+  # https://discourse.cmake.org/t/migration-experiences-comparison-runtime-dependency-set-vs-fixup-bundle-bundleutilities
+  install(RUNTIME_DEPENDENCY_SET dependencies DESTINATION ${CMAKE_INSTALL_BINDIR} PRE_EXCLUDE_REGEXES [[api-ms-win-.*]] [[ext-ms-.*]] POST_EXCLUDE_REGEXES [[.*(\\|/)system32(\\|/).*\.dll]])
 endif()
 
 # Configure CMake helpers

=== joss/Makefile ===
THIS = basix-paper

.PHONY: all pdf

all: pdf

pdf:
	docker run --rm --volume $(shell pwd):/data --user $(id -u):$(id -g) --env JOURNAL=joss openjournals/paperdraft

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
   set(CMAKE_OSX_DEPLOYMENT_TARGET "10.14")
 endif()
 
-project(basix_nanobind VERSION "0.9.0.0" LANGUAGES CXX)
+project(basix_nanobind VERSION "0.10.0" LANGUAGES CXX)
 
 if (WIN32)
     # Windows requires all symbols to be manually exported.
@@ -20,7 +20,15 @@
   find_package(Basix REQUIRED)
 endif()
 
-find_package(Python COMPONENTS Interpreter Development.Module REQUIRED)
+find_package(Python COMPONENTS Interpreter Development.Module ${SKBUILD_SABI_COMPONENT} REQUIRED)
+
+# Options
+include(FeatureSummary)
+
+option(ENABLE_CLANG_TIDY "Run clang-tidy while building" OFF)
+add_feature_info(ENABLE_CLANG_TIDY ENABLE_CLANG_TIDY "Run clang-tidy while building")
+
+feature_summary(WHAT ALL)
 
 # Detect the installed nanobind package and import it into CMake
 execute_process(
@@ -30,16 +38,28 @@
 find_package(nanobind CONFIG REQUIRED)
 
 # Create the binding library
-nanobind_add_module(_basixcpp wrapper.cpp)
+if(NOT "${SKBUILD_SABI_VERSION}" STREQUAL "")
+  set(NANOBIND_SABI "STABLE_ABI")
+endif()
+nanobind_add_module(_basixcpp NB_SUPPRESS_WARNINGS ${NANOBIND_SABI} wrapper.cpp)
 target_compile_definitions(_basixcpp PRIVATE cxx_std_20)
+
+if(ENABLE_CLANG_TIDY)
+  find_program(CLANG_TIDY NAMES clang-tidy REQUIRED)
+  set_target_properties(_basixcpp PROPERTIES CXX_CLANG_TIDY "${CLANG_TIDY};--config-file=${CMAKE_CURRENT_SOURCE_DIR}/../.clang-tidy")
+endif()
+
 target_link_libraries(_basixcpp PRIVATE Basix::basix)
 
 # Add strict compiler flags
 include(CheckCXXCompilerFlag)
-CHECK_CXX_COMPILER_FLAG("-Wall -Werror -Wextra -Wno-comment -pedantic" HAVE_PEDANTIC)
-
+check_cxx_compiler_flag("-Wall -Werror -Wextra -pedantic" HAVE_PEDANTIC)
 if(HAVE_PEDANTIC)
-  target_compile_options(_basixcpp PRIVATE -Wall;-Wextra;-Werror;-Wno-comment)
+  target_compile_options(_basixcpp PRIVATE -Wall;-Werror;-Wextra;-Wno-comment;-pedantic)
+  # Intel's complex header uses #include_next which is not allowed with -Wall
+  if (CMAKE_CXX_COMPILER_ID STREQUAL "IntelLLVM")
+    target_compile_options(_basixcpp PRIVATE -Wno-gnu-include-next)
+  endif()
 endif()
 
 # TODO: remove after issue https://github.com/FEniCS/basix/issues/842 is resolved

=== demo/cpp/demo_dof_transformations/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(demo_dof_transformations LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Use Python for detecting Basix when installed using combined build
find_package(Python3 COMPONENTS Interpreter)
if (${Python3_FOUND})
  execute_process(
    COMMAND ${Python3_EXECUTABLE} -c "import basix, os, sys; sys.stdout.write(os.path.dirname(basix.__file__))"
    OUTPUT_VARIABLE BASIX_PY_DIR
    RESULT_VARIABLE BASIX_PY_COMMAND_RESULT
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
  if (BASIX_PY_DIR)
    message(STATUS "Adding ${BASIX_PY_DIR} to Basix search hints")
  endif()
endif()
find_package(Basix REQUIRED CONFIG HINTS ${BASIX_PY_DIR})

add_executable(${PROJECT_NAME} main.cpp)

if (BASIX_PY_DIR AND IS_DIRECTORY ${BASIX_PY_DIR}/../fenics_basix.libs)
    set_target_properties(${PROJECT_NAME} PROPERTIES BUILD_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
    set_target_properties(${PROJECT_NAME} PROPERTIES INSTALL_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
endif()
target_link_libraries(${PROJECT_NAME} Basix::basix)

=== debian/changelog ===
fenics-basix (0.10.0.post0-1exp1) experimental; urgency=medium

  * New upstream release. New ABI 0.10.
    - Depends: python3-ufl (>= 2025.2.0~)
  * debian/test: monitor and skip slowest tests on armel alongside
    riscv64. Thanks Colin Watson. Closes: #1090766
  * update debian/watch to Version 5 format for GitHub.
    Needed to catch .post0 releases.

 -- Drew Parsons <dparsons@debian.org>  Wed, 12 Nov 2025 11:00:49 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                dh-sequence-python3,
                python3-setuptools,
                python3-all-dev:any,
-               python3-ufl (>= 2024.2.0~),
+               python3-ufl (>= 2025.2.0~),
                python3-nanobind (>= 2.0.0~),
                python3-numpy,
                pybuild-plugin-pyproject,
@@ -38,7 +38,7 @@
 Package: libbasix-dev
 Architecture: any
 Multi-Arch: same
-Depends: libbasix0.9 (= ${binary:Version}),
+Depends: libbasix0.10 (= ${binary:Version}),
          libeigen3-dev,
          ${misc:Depends},
          ${shlibs:Depends}
@@ -64,7 +64,7 @@
  .
  This package installs the development files for the shared library.
 
-Package: libbasix0.9
+Package: libbasix0.10
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends},
@@ -94,7 +94,7 @@
 Package: python3-basix
 Architecture: any
 Depends: libbasix-dev  (= ${binary:Version}),
-         python3-ufl (>= 2024.1.0~),
+         python3-ufl (>= 2025.2.0~),
          ${python3:Depends},
          ${misc:Depends},
          ${shlibs:Depends}

=== debian/tests/control ===
Tests: run-tests,
# gcc is not really used, but added to silence the dpkg-architecture warning
# cannot determine CC system type, falling back to default (native compilation)
Depends: python3-basix,
 python3-all,
 python3-pytest,
 python3-ufl,
 python3-numpy,
 python3-sympy,
 gcc

=== debian/watch ===
Version: 5

Template: GitHub
Owner: FEniCS
Project: basix
